**note:** this is all still pretty early, please be patient while I work on the scripts and documentation.

# what is this?
opus-nt is a homebrew for Windows longhorn-series (Vista or up), striving for stability and performance. it is inspired by the simplicity of earlier Windows versions. there are no extreme tweaks applied, the goal is to stay within semi-official territory to prevent breakage on feature updates.

the homebrew-framework is very adaptable, and can be expanded with more tweaks or for other longhorn-based systems pretty easily. opus-nt and its framework may be distributed in whichever way you want. knock yourself out!

[**a complete list of tweaks**](docs/tweaks.md)

# what do I need?   
- an ISO of Windows Vista or up (longhorn-series). any edition should be fine, as long as it has a file in /sources/ called install.wim.   
- a system running Windows Vista or up (full linux support and XP support is planned)   
- [Python 3.x](https://www.python.org/) and [Munch](https://pypi.org/project/munch/)   
- [wimlib](https://wimlib.net/)   
- when on windows, a means of running the python script as NT AUTHORITY\SYSTEM, like [PsExec](https://docs.microsoft.com/en-us/sysinternals/downloads/psexec)   